# Copyright 1999-2006 Gentoo Foundation
# Distributed under the terms of the GNU General Public License v2
# $Header: $

inherit eutils

#note: must update this for later releases, as well as SRC_URI
MY_P="20051130084614343_DriversPack-1.0.165.tar.gz"

DESCRIPTION="Samsung SCX/MFP drivers"
HOMEPAGE="http://www.samsung.com/support/productsupport/download/index.aspx"
SRC_URI="http://org.downloadcenter.samsung.com/downloadfile/ContentsFile.aspx?VPath=DR/200511/20051130084614343_DriversPack-1.0.165.tar.gz"

LICENSE="as-is"
SLOT="0"
KEYWORDS="~amd64 x86"
IUSE="scanner"

#FIXME: add support for lprng/foomatic? still needs cups since raster* bins are linked against it
#FIXME: add support for their kernel modules

DEPEND="virtual/ghostscript
	net-print/cups
	scanner? ( media-gfx/sane-backends ) "
RDEPEND="sys-libs/lib-compat"

src_unpack() {
	unpack ${A}
	cd cdroot/Linux
	if [ "${ARCH}" == "x86" ]; then
		tar xf rd/mfpcommon.ss
		for i in models/*/*.ss; do
			tar xf ${i}
		done
	fi
}

src_install() {
	cd ${D}
	dodir /opt/samsungmfp/lib
	dodir /opt/samsungmfp/bin
	into /opt/samsungmfp
	if [ "${ARCH}" == "x86" ]; then
		dobin ${WORKDIR}/cdroot/Linux/usr/local/bin/samsung/rastertosamsung*
		dolib ${WORKDIR}/cdroot/Linux/usr/local/bin/samsung/libGDI.so.1.0.0
		dolib ${WORKDIR}/cdroot/Linux/usr/local/bin/samsung/libmfp.so.1.0.1
		dolib ${WORKDIR}/cdroot/Linux/usr/local/bin/samsung/libmfpdetect.so.1.0.1
		dolib ${WORKDIR}/cdroot/Linux/usr/local/bin/samsung/libqt-mt.so.3.0.4
	else
		dobin ${WORKDIR}/cdroot/Linux/x86_64/rastertosamsung*
		dolib ${WORKDIR}/cdroot/Linux/x86_64/*.so*
	fi
	ldconfig -n ${D}/opt/samsungmfp/lib
	mv ${D}/opt/samsungmfp/lib/libqt-mt.so.3 ${D}/opt/samsungmfp/lib/libqt-mt.samsung-mfp.so.3
	mv ${D}/opt/samsungmfp/lib/libqt-mt.so.3.0.4 ${D}/opt/samsungmfp/lib/libqt-mt.samsung-mfp.so.3.0.4
	dodir /usr/share/cups/model/samsung
	insinto /usr/share/cups/model/samsung
	doins ${WORKDIR}/cdroot/Linux/usr/share/cups/model/samsung/*.ppd

	if use scanner; then
		dodir /usr/lib/sane
		if [ "${ARCH}" == "amd64" ]; then
			dolib ${WORKDIR}/cdroot/Linux/x86_64/libsane* /usr/lib/sane
			SCANNERS="mfp560 mfp750 scx4100 scx4x16 scx4x20 scx4x21 scx5312f scx6x20 sf531fp" 
		else
			dolib ${WORKDIR}/cdroot/Linux/usr/lib/sane/libsane*.so.1.0.1 /usr/lib/sane
			SCANNERS="mfp560 mfp750 scx4100 scx4200 scx4x16 scx4x20 scx4x21 scx6x20" 
		fi
		ldconfig -n ${D}/opt/samsungmfp/lib


		for i in ${SCANNERS}; do 
			dosym /opt/samsungmfp/lib/libsane-samsung_$i.so /usr/lib/sane/libsane-samsung_$i.so
			dosym /opt/samsungmfp/lib/libsane-samsung_$i.so.1 /usr/lib/sane/libsane-samsung_$i.so.1
			dosym /opt/samsungmfp/lib/libsane-samsung_$i.so.1.0.1 /usr/lib/sane/libsane-samsung_$i.so.1.0.1
		done

		einfo "To enable scanning, add the proper line to /etc/sane.d/dll.conf"
		einfo "e.g. samsung_scx4100 and make sure that the user has permissions"
		einfo "to access /dev/usb/lp0"
	fi

	exeinto /usr/lib/cups/filter
	doexe ${FILESDIR}/rastertosamsung*
}
